#!/bin/sh

all_users=$(grep /home < /etc/passwd | awk -F: '{print $1}')
current_dir=$(dirname "$(readlink -f "$0")")
template_dir="${current_dir}/templates/gemini"
output="${template_dir}/users.gemini"
printf "[Users]\\n" > "$output"
printf "%s" "$all_users" | while read -r n; do
  if [ -f "/var/gemini/users/${n}/.gemini" ]; then
    printf "=> /users/%s ~%s\\n" "$n" "$n" >> "$output"
  fi
done

cat "${template_dir}/head.gemini" "${output}" > /var/gemini/.gemini
cat "$output" > /var/gemini/users/.gemini
